<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page
        import="org.wso2.carbon.module.mgt.ui.client.ModuleManagementClient" %>
<%@ page import="org.wso2.carbon.module.mgt.ui.client.Parameter" %>
<%@ page import="java.util.List" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<jsp:include page="../dialog/dialog_header.jsp"/>
<fmt:bundle basename="org.wso2.carbon.module.mgt.ui.i18n.Resources">
    <carbon:breadcrumb label="module.parameters.breadcrumb.text"
                       resourceBundle="org.wso2.carbon.module.mgt.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>

    <%
        String moduleName = request.getParameter("moduleName");
        String moduleVersion = request.getParameter("moduleVersion");
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

        List<Parameter> params;
        try {
            ModuleManagementClient stub = new ModuleManagementClient(configContext, backendServerURL, cookie, false);
            params = stub.getModuleParameters(moduleName,moduleVersion);
        } catch (Exception e) {
    %>
    <jsp:forward page="../admin/error.jsp?<%=e.getMessage()%>"/>
    <%
            return;
        }
    %>
    <div id="middle">
        <h2>
            <fmt:message key="module.parameters">
                <fmt:param value="<%=moduleName%>"/>
            </fmt:message>
        </h2>

        <div id="workArea">
            <script type="text/javascript">
                function removeModuleParameter(parameter) {
                    var resp = confirm("<fmt:message key="remove.parameters.prompt"/> '" + parameter + "' ?");
                    if (resp) {
                        location.href = "remove_parameters_ajaxprocessor.jsp?moduleName=<%=moduleName%>&moduleVersion=<%=moduleVersion%>&parameterName=" + parameter;
                    }
                }

                function addModuleParameter() {

                    var paramName = prompt("<fmt:message key="new.parameter.name"/>", "");
                    if (paramName == null || jQuery.trim(paramName) == '') {
                        return;
                    } else if (document.getElementById(paramName) != null) {
                        CARBON.showWarningDialog("Module parameter " + paramName + " already exists");
                        return;
                    }

                    paramName = jQuery.trim(paramName);

                    //add a row to the rows collection and get a reference to the newly added row
                    var newRow = document.getElementById("paramTable").insertRow(-1);

                    //        newRow.className = "even";

                    //add 6 cells (<th>) to the new row and set the innerHTML to contain text boxes
                    var oCell = newRow.insertCell(-1);
                    oCell.innerHTML = paramName;

                    oCell = newRow.insertCell(-1);
                    oCell.innerHTML =
                    "<textarea rows=\"3\" cols=\"40\" name=" + paramName + ">" +
                    "&lt;parameter name=\"" + paramName + "\" locked=\"false\"&gt;\n" +
                    "TODO: <fmt:message key="enter.value.here"/>\n" +
                    "&lt;/parameter&gt;" +
                    "</textarea>";

                    oCell = newRow.insertCell(-1);
                    oCell.innerHTML =
                    "<a title='<fmt:message key="remove.parameter"/>'" +
                    "onclick=\"removeModuleParameter('" + paramName + "');return false;\"" +
                    "href='#' class=\"icon-link\" " +
                    "style=\"background-image:url(../admin/images/delete.gif);\"><fmt:message key="delete"/></a>";
                }

                function getModuleInfo(moduleName,moduleVersion) {
                    location.href ="./module_info.jsp?moduleName="+moduleName+"&moduleVersion="+moduleVersion+'&ordinal=1';
                }

            </script>
            <form action="setParameters.jsp" method="post">
                <input type="hidden" name="moduleName" value="<%=moduleName%>"/>
                <input type="hidden" name="moduleVersion" value="<%=moduleVersion%>"/>
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="edit.parameters"/></th>
                    </tr>
                    </thead>
                    <tr>
                        <td class="formRaw">
                            <table class="normal" id="paramTable" width="100%">
                                <tbody>
                                <%
                                    for (Parameter param : params) {
                                %>
                                <tr style="clear: both;">
                                    <td>
                                        <label id="<%= param.getName()%>"><%= param.getName()%>
                                        </label>
                                    </td>
                                    <%
                                        if (param.isLocked()) {
                                    %>
                                    <td>
                                        <textarea rows="3" cols="40" readonly="true"
                                                  name="<%= param.getName()%>"><%= param.getValue()%>
                                        </textarea>
                                    <td>
                                    </td>
                                    <%
                                        } else {
                                    %>
                                    <td>
                                        <textarea rows="3" cols="40"
                                                  name="<%= param.getName()%>"><%= param.getValue()%>
                                        </textarea>
                                    <td>
                                        <a title="<fmt:message key="remove.parameter"/>"
                                           onclick="removeModuleParameter('<%= param.getName()%>');return false;"
                                           href="#" class="icon-link"
                                           style="background-image:url(../admin/images/delete.gif);">
                                            <fmt:message key="delete"/>
                                        </a>
                                    </td>
                                    <%
                                        }
                                    %>
                                </tr>
                                <%
                                    }
                                %>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <input type="submit" class="button"
                                   value="<fmt:message key="update.parameter"/>"/>
                            <input onclick="addModuleParameter();return false;"
                                   value="<fmt:message key="add.new.parameter"/>"
                                   type="button" class="button">
                            <input onclick="getModuleInfo('<%=moduleName%>','<%=moduleVersion%>');return false;"
                                   value="<fmt:message key="cancel"/>"
                                   type="button" class="button">
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>