<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<%@ page import="org.wso2.carbon.registry.ui.resource.clients.ResourceServiceClient" %>
<%@ page import="java.util.List" %>
<%@ page import="org.wso2.carbon.registry.ui.common.UIConstants" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.registry.ui.resource.Utils" %>
<%@ page import="org.wso2.carbon.registry.ui.resources.common.xsd.WebResourcePath" %>
<%@ page import="org.wso2.carbon.registry.ui.resources.beans.xsd.MetadataBean" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    String viewMode = Utils.getResourceViewMode(request);
    String resourceConsumer = Utils.getResourceConsumer(request);
    String targetDivID = Utils.getTargetDivID(request);
    MetadataBean metadata;
    try {
        ResourceServiceClient client = new ResourceServiceClient(cookie, config, session);
        metadata = client.getMeatadata(request);
    } catch (Exception e) {
%>
<jsp:forward page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }
%>

<fmt:bundle basename="org.wso2.carbon.registry.ui.resource.i18n.Resources">
<script type="text/javascript"
        src="../resources/js/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>


<div class="box1-head" style="height:auto;">
    <table cellspacing="0" cellpadding="0" border="0" style="width:100%">
        <tr>
            <td style="padding-left:5px;">
                <h2>
                    <%
                        WebResourcePath[] iNavPaths = metadata.getNavigatablePaths();
                        boolean found = false;
                        if (iNavPaths.length > 0) {
                            WebResourcePath rootPath = iNavPaths[0];

                            if (iNavPaths.length > 2) {
                                for (int i = 2; i < iNavPaths.length; i++) {
                                    WebResourcePath resourcePath = iNavPaths[i];

                                    if (i == iNavPaths.length - 1) {
                                        found = true;
                    %>
                    <%=resourcePath.getNavigateName()%>
                    <%
                                }
                            }
                        }
                        if (iNavPaths.length > 1 && !found) {
                            WebResourcePath childPath = iNavPaths[1];
                            found = true;
                    %>
                    <%=childPath.getNavigateName()%>
                    <%
                            }
                        }
                        if (!found) {
                    %>
                    root /
                    <%
                        }
                    %>
                </h2>

            </td>
            <td align="right" valign="top" class="box1-head-right">
                <table cellpadding="0" cellspacing="0" border="0" style="margin-top:5px;">
                    <tr>
                        <td>
                        </td>
                        <td>
                            <a onclick="showHideCommon('mainDetailsIconExpanded');showHideCommon('mainDetailsIconMinimized');showHideCommon('resourceMainDetails');showHideCommon('resourceMainDetailsMin');">
                                <img src="../resources/images/icon-expanded.gif" border="0"
                                     align="top"
                                     id="mainDetailsIconExpanded"/>
                                <img src="../resources/images/icon-minimized.gif" border="0"
                                     align="top"
                                     id="mainDetailsIconMinimized" style="display:none;"/>
                            </a>
                        </td>
                    </tr>
                </table>
            </td>

        </tr>
    </table>
</div>


<div class="box1-mid" id="resourceMainDetails">
    <table class="normal" style="width:100%;">
        <tr>

            <% if (metadata.getVersionView()) { %>
            <td>
                <a
                        style="background-image:url(../resources/images/back.gif)"
                        class="icon-link"
                        onclick="loadVersionPage('<%=metadata.getActiveResourcePath()%>','<%=viewMode%>','<%=resourceConsumer%>','<%=targetDivID%>')">
                    <fmt:message key="back.to.versions.of"/> <%=metadata.getActiveResourcePath()%>
                </a>

                <% if (metadata.getPutAllowed()) { %>

                <a
                        style="background-image:url(../resources/images/icon-restore.gif)"
                        class="icon-link"
                        onclick="restoreVersion('../resources/restore_version_ajaxprocessor.jsp?versionPath=<%=metadata.getPath()%>&path=<%=metadata.getActiveResourcePath()%>&resourceViewMode=<%=viewMode%>&resourcePathConsumer=<%=resourceConsumer%>&targetDivID=<%=targetDivID%>','<%=viewMode%>','<%=targetDivID%>')"
                        >
                    <fmt:message key="restore.to.this.version"/> </a>
            </td>
            <% } %>
            <% } %>
            <td align="right" style="text-align:right !important;">
                <%
                    String atomPath = metadata.getPath();
                    // If this is an entry, can't subscribe directly, so use logs feed
                    if (!metadata.getCollection()) {
                        atomPath += ";logs";
                    }
                %>
                <a
                        style="float:right;background-image:url(../admin/images/icon-feed-small-res.gif);"
                        href="<%=Utils.getAtomURL(request, atomPath)%>"
                        target="_blank"
                        class="icon-link"
                        title="Subscribe to the resource feed">
                    <fmt:message key="feed"/>
                </a>
            </td>
        </tr>
    </table>


    <table cellpadding="0" cellspacing="0" border="0" class="styledLeft" id="mainDetails">
        <tbody>
        <tr>
            <td style="width:140px;"><fmt:message key="created"/>:</td>
            <td colspan="2">
                <fmt:message
                        key="by"/> <%=metadata.getAuthor()%> <%=metadata.getFormattedCreatedOn()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="last.updated"/>:</td>
            <td colspan="2">
                <fmt:message
                        key="by"/> <%=metadata.getLastUpdater()%> <%=metadata.getFormattedLastModified()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="media.type1"/>:</td>
            <td colspan="2"><% if (metadata.getMediaType() != null && metadata.getMediaType().length() != 0) { %><%=metadata.getMediaType()%><% } else { %>
                <fmt:message key="unknown"/><% } %></td>
        </tr>

        <tr>
            <td valign="top"><fmt:message key="permalink"/>:</td>
            <td colspan="2">
                <div id="permalinkdiv">
                    <% if (!metadata.getVersionView()) { %>
                    <ul>
                        <li>
                            <% if (metadata.getPutAllowed()) { %>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/create-checkpoint.gif);"
                               href="javascript:createVersion('<%=metadata.getPath()%>','<%=viewMode%>','<%=resourceConsumer%>','<%=targetDivID%>')">Create
                                <fmt:message key="checkpoint"/></a>
                            <% } %>
                        </li>
                        <li>
                        </li>
                    </ul>

                    <% } else { %>

                    <%=metadata.getPermalink()%>

                    <% } %>
                </div>
            </td>
        </tr>

        <% if (!metadata.getVersionView()) { %>
        <tr>
            <td><fmt:message key="versions"/>:</td>
            <td colspan="2"><a href="#"
                               onclick="loadVersionPage('<%=metadata.getPath()%>','<%=viewMode%>','<%=resourceConsumer%>','<%=targetDivID%>')"
                               class="view-icon-link"><fmt:message key="view.versions"/></a></td>
        </tr>
        <% } %>

        <tr>
            <td style="width:120px; padding-bottom:10px; " valign="top"><fmt:message
                    key="description"/>:
            </td>
            <td valign="top" colspan="2">
                <% if (metadata.getPutAllowed() && !metadata.getVersionView()) { %>
                <div id="descView" style="display:block;">
                    <% if (metadata.getDescription() != null) { %> <%=metadata.getDescription()%> <% } %>
                </div>
                <div id="editButton" style="display:inline;">
                    <a name="editButtonLink"
                       onclick="processDescription('<%=metadata.getPathWithVersion()%>','editing');"
                       class="edit-icon-link"><fmt:message key="edit"/></a>
                </div>
                <div class="yui-skin-sam">
                    <textarea class="resource-content" id="descEdit" name="descEdit"
                              style="display:none;"></textarea>
                </div>
                <div id="saveButton" style="display:none;">
                    <a name="saveButtonLink"
                       onclick="processDescription('<%=metadata.getPathWithVersion()%>','saving');"
                       class="save-icon-link"><fmt:message key="save"/></a>
                    <a name="saveButtonLink"
                       onclick="processDescription('','cancel');"
                       class="cancel-save-icon-link"><fmt:message key="cancel"/></a>
                </div>
                <% } %>
            </td>
        </tr>
        </tbody>
    </table>

</div>
<div id="resourceMainDetailsMin" style="height:10px;display:none">
</div>
<script type="text/javascript">
    alternateTableRows('mainDetails', 'tableEvenRow', 'tableOddRow');
</script>
</fmt:bundle>