<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.wso2.carbon.registry.ui.resource.processors.GetResourceTreeProcessor" %>
<%@ page import="org.wso2.carbon.registry.core.RegistryConstants" %>
<%@ page import="org.wso2.carbon.registry.ui.resource.Utils" %>
<%@ page import="org.wso2.carbon.registry.ui.resource.clients.ResourceServiceClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%
    String viewMode = Utils.getResourceViewMode(request);
    String actionStyle = "inlined".equals(viewMode) ? "display:none;" : "";     
    String resourceConsumer = Utils.getResourceConsumer(request);      
    String errorMessage = null;
    String textBoxId = request.getParameter("textBoxId");
    String synapseRegistryMetaDataRootPath =
             RegistryConstants.ROOT_PATH + "carbon" + RegistryConstants.PATH_SEPARATOR + "synapse-registries";
    String synapseRegistryRoot = "";
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        ResourceServiceClient client = new ResourceServiceClient(cookie, config, session);
        synapseRegistryRoot = client.getProperty(synapseRegistryMetaDataRootPath, "SYNAPSE_REGISTRY_ROOT");           
    } catch (Exception ignored) {
    }
%>
<script type="text/javascript" src="../resources/js/resource_util.js"></script>
<script src="../carbon/global-params.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="../resources/css/registry.css"/>
<fmt:bundle basename="org.wso2.carbon.registry.ui.resource.i18n.Resources">
    <% if (errorMessage != null) { %>

    <script type="text/javascript">
        location.href = '../error.jsp?errMsg=<%=errorMessage%>'
    </script>

    <% } else { %>
    <div class="close-button-position">
        <a onclick="closeResourceTree()" border="0">
            <img src="../resources/images/icon-close.gif"/></a>
    </div>
    <div class="headding-tree-back">
        <h1 class="headding-tree"><fmt:message key="resource.paths"/></h1>
    </div>
    <% if ("inlined".equals(viewMode)) {%>
    
        <table class="styledLeft">
        	<tbody>
        	<tr>
        	<td class="leftCol-small" style="border-right:none"><fmt:message key="local.registry"/></td>
        	<td style="border-left:none">
            <div id="local-registry-workArea" name="local-registry-workArea" style="margin-top:5px;margin-bottom:5px;"></div>
            <script type="text/javascript">
                var url = '../sequences/local_registry-ajaxprocessor.jsp?resourceConsumer=' + '<%=Utils.getResourceConsumer(request)%>';
                jQuery("#local-registry-workArea").load(url, null,
                        function(data, status, t) {
                            if (status != "success") {
                                CARBON.showWarningDialog("Error Occurred!");
                                document.getElementById("local-registry-td").style.display = "none";
                            }
                        });
        </script>
        	</td>
        	</tr>
        	</tbody>
        </table>
        
        
    
    <%}%>
    <div class="resource-tree-headding">
        <fmt:message key="picked.path"/> : <input type="text" id="pickedPath"
                                                class="picked-path-textbox" style="width:500px;"
                                                onfocus="setResolvedResourcePathOnConsumer('<%=resourceConsumer%>','<%=synapseRegistryRoot%>')" onchange="setResolvedResourcePathOnConsumer('<%=resourceConsumer%>','<%=synapseRegistryRoot%>')"/>
                                            <input type="button" class="button" value="OK" onclick="CARBON.closeWindow()" />    
    </div>
    <div class="resource-tree-box">
    <%--<%=resourceTree%>--%>
        <div id="father_root" class="father-object">
            <a onclick="loadSubTree('/', 'root', '<%=textBoxId%>');">
                <img style="margin-right: 5px;" id="plus_root" src="../resources/images/icon-tree-plus.jpg"/>
                <img style="display:none; margin-right: 5px;" id="minus_root" src="../resources/images/icon-tree-minus.jpg"/></a>
            <a onclick="pickPath('/', '<%=textBoxId%>');"><img style="margin-right: 2px;"
                                                                  src="../resources/images/icon-folder-small.gif"/>/</a>
        </div>
        <div id="child_root" class="child-objects"></div>
    </div>
    <% } %>
</fmt:bundle>